package Assem;

public class InstrList
{
  InstrNode head;
  InstrNode last;
 
  public InstrList() {
    // dummy node for easy management
    head = new InstrNode(null, null);
    last = head;
  }

  public InstrList(Instr e) {
    this();
    addInTail(e);
  }
  
  public InstrList(InstrNode e) {
    this();
    addInTail(e);
  }
  
  public void addInTail(Instr e) {
  	if(e == null) return;
    InstrNode node = new InstrNode(e, null);
    last.tail = node;
    last = node;
  }

  public void addInTail(InstrNode node) {
  	  if(node == null) return;
      last.tail = node;
      last = node.getLast();
  }

  public void addInFront(Instr e) {
    InstrNode node = new InstrNode(e, head.tail);
    head.tail = node;
  }

  public void addInFront(InstrNode node) {
    node.getLast().tail = head.tail;
    head.tail = node;
  }

  public InstrNode first() {
    return head.tail;
  }

  public boolean empty() {
    return head.tail == null;
  }
}

