package ErrorMsg;

public class ErrorMsg
{
  private LineList linePos = new LineList(-1,null);
  private int lineNum=1;
  private String filename;
  public boolean anyErrors;

  private boolean useErrorStr = false;
  private StringBuffer errorStr = new StringBuffer(1024);

  public int semanticErrors = 0;

  public ErrorMsg(String f)
  {
      filename = (f == null) ? "stdin" : f;
  }

  public ErrorMsg(String f, boolean useErrorStr)
  {
      this(f);
      this.useErrorStr = useErrorStr;	
  }

  public void newline(int pos)
  {
     lineNum++;
     linePos = new LineList(pos,linePos);
  }

  public void error(int pos, String msg)
  {
	int n = lineNum;
        LineList p = linePos;
	String sayPos="0.0";
        String str;

	anyErrors=true;

        while (p!=null) {
          if (p.head<pos) {
	     sayPos = String.valueOf(n) + "." + String.valueOf(pos-p.head);
	     break;
          }
	  p=p.tail; n--;
        }

	str = new String("ERROR (" + filename + ":" + sayPos + ") \n" + msg);
	if (useErrorStr) errorStr.append(str+"\n"); 
        System.out.println(str);
  }

  public String getErrorString() { return errorStr.toString(); }

}

class LineList
{
  int head;
  LineList tail;
  LineList(int h, LineList t) {head=h; tail=t;}
}
