package RegAlloc;

import Graph.*;
import FlowGraph.*;
import Temp.*;

import java.util.Hashtable;

public class Liveness extends InterferenceGraph
{
  AssemFlowGraph graph;
  Hashtable liveMap;  //per associare ad ogni flow-nodo i temp live-out 
  Hashtable tton;  //per associare ad ogni temp il nodo
  Hashtable ntot;  //per associare ad ogni nodo il temp
  MoveList moves;

  public Liveness(AssemFlowGraph x){
    graph=x;
    liveMap=new Hashtable();       
    tton=new Hashtable();       
    ntot=new Hashtable();       
    //si inseriscono le liveMap
    NodeList l=graph.nodes();
    while(l!=null){
      TempNode ttl0=graph.out(l.head);
      if(ttl0!=null) liveMap.put(l.head,ttl0);
      //si inseriscono i nodi di inference
      TempNode lt=graph.def(l.head);
      while(lt!=null){
        if(!tton.containsKey(lt.head)){
          Node act=newNode();
          tton.put(lt.head,act);
          ntot.put(act,lt.head);
        }
        lt=lt.tail;
      }
      lt=graph.use(l.head);
      while(lt!=null){
        if(!tton.containsKey(lt.head)){
          Node act=newNode();
          tton.put(lt.head,act);
          ntot.put(act,lt.head);
        }
        lt=lt.tail;
      }
      l=l.tail;
    }

    //si inseriscono le moves    
    moves=null;
    NodeList fgnl=graph.nodes();
    while(fgnl!=null){
      if(graph.isMove(fgnl.head)){      
        Assem.MOVE act=(Assem.MOVE)graph.getInstr(fgnl.head);
        Node dest=(Node)tton.get(act.dst);
        Node sorg=(Node)tton.get(act.src);
        addMoves(dest,sorg);        
      }
      fgnl=fgnl.tail;
    }

    //si inseriscono gli archi
    l=graph.nodes();
    while(l!=null){
      TempNode lt=graph.def(l.head);
      TempNode lo=(TempNode)liveMap.get(l.head);
      while(lt!=null){        
        Node ndnd=(Node)tton.get(lt.head);
        Assem.Instr inin=graph.getInstr(ndnd);
        boolean opt=false;        
        Temp check=null;
        if(inin instanceof Assem.MOVE){opt=true;check=((Assem.MOVE)inin).src;}
        else opt=false;
        while(lo!=null){  
          if(!opt) addEdge(ndnd,(Node)tton.get(lo.head));
          else
            if(check!=lo.head)addEdge(ndnd,(Node)tton.get(lo.head));  
          lo=lo.tail;
        }        
        lt=lt.tail;
      }

      l=l.tail;
    }
   
  }

  public void addEdge(Node a,Node b){
    if(a==b)return;
    super.addEdge(a,b);
    super.addEdge(b,a);
  }
  public void rmEdge(Node a,Node b){
    super.rmEdge(a,b);
    super.rmEdge(b,a);
  }

  public Node tnode(Temp temp){return (Node)tton.get(temp);}

  public Temp gtemp(Node node){return (Temp)ntot.get(node);}

  public MoveList moves(){return moves;}

  private void addMoves(Node d,Node s)
  {
    if(moves==null) moves=new MoveList(s,d,null);
    else {
      MoveList app=moves;
      while(app.tail!=null){app=app.tail;}
      app.tail=new MoveList(s,d,null);
    }
  }

}

