package Translate;

import java.util.Hashtable;

public class Translate
{
  private int wordSize;
  public static Exp errExp=new Nx(new Tree.LABEL(new Temp.Label("Errore")));
  public static Exp dicExp=new Nx(new Tree.EXP2(new Tree.CONST(0)));

  public static final Hashtable stol=new Hashtable();

  //lista fragment
  private static Frag frags;

  public Translate(){frags=null; wordSize=4;}
  public Translate(int ws){frags=null; wordSize=ws;}

  public void procEntryExit(Level level,Exp body,boolean isVoid){
    Tree.Stm nbody;

    if(!isVoid)
     nbody=level.frame.procEntryExit1(
         new Tree.MOVE(
                  new Tree.TEMP(level.frame.RV()),
                  body.unEx()
         )
      );

    else nbody=level.frame.procEntryExit1(body.unNx());

    Tree.StmList cbody=
       new Canon.TraceSchedule(
          new Canon.BasicBlocks(
              Canon.Canon.linearize(nbody))
       ).stms;
    insertInFrag(new ProcFrag(nbody,cbody,level.frame));
  }

  public void insProgram(Exp t,Frame.Frame b){
    Tree.StmList cbody=
       new Canon.TraceSchedule(
          new Canon.BasicBlocks(
              Canon.Canon.linearize(t.unNx()))
       ).stms;
    insertInFrag(new ProcFrag(t.unNx(),cbody,b));
  }

  private void insertInFrag(Frag p){
    if(frags==null) frags=p;
    else{ p.next=frags;frags=p;}
  }

  public static Frag getResult(){return frags;}

  public void functionDec(Level act,Exp body,boolean isVoid){
    Temp.Label oo=new Temp.Label();
    Exp nbody=body;
    if(body==null)
      nbody=new Nx(new Tree.SEQ(new Tree.JUMP(oo),new Tree.LABEL(oo)));
    procEntryExit(act,nbody,!isVoid);
  }

  //il metodo restituisce l'indirizzo del FP del livello ll dal livello attuale al
  private Tree.Exp dichFP (Level ll,Level al,Tree.Exp FP) {
    if ( ll == al ) return FP;
    return dichFP(ll,al.parent,al.frame.formals.head.exp(FP));
  }


  public Exp simpleVar(Access vv, Level al) {
    Tree.TEMP FP = new Tree.TEMP(vv.home.frame.FP());
    return new Ex(vv.acc.exp(dichFP(vv.home,al,FP)));
  }

    //il primo elemento rappresenta la size dell'array
  public Exp subscriptVar(Exp rr,Exp index,Level act){

    Temp.Temp nidx=new Temp.Temp();

    Tree.MOVE midx=new Tree.MOVE(new Tree.TEMP(nidx),index.unEx());

    Exp idxT=new Ex(new Tree.TEMP(nidx));

    Exp c1=
     binOpExp(Tree.BINOP.OR,
         (new RelCx(Tree.CJUMP.LT,idxT,new Ex(new Tree.CONST(0)))),
         (new RelCx(Tree.CJUMP.GE,idxT,new Ex(new Tree.MEM(rr.unEx()))))
     );

     Tree.Exp res=
         new Tree.BINOP(
             Tree.BINOP.PLUS,
             rr.unEx(),
             new Tree.BINOP(
                Tree.BINOP.MUL,
                new Tree.CONST(act.frame.wordSize()),
                new Tree.BINOP(
                  Tree.BINOP.PLUS,
                  idxT.unEx()
                  ,
                  new Tree.CONST(1)
                )
             )

         );

     Tree.SEQ err=new Tree.SEQ(
       new Ex(act.frame.externalCall(
           "print",
           new Tree.ExpList(stringExp(act,"\nErrore di runtime : l'indice dell'array e' fuori dai limiti.\n").unEx(),null)
       )).unNx(),
      new Ex( act.frame.externalCall(
           "exit",
           new Tree.ExpList(intExp(0).unEx(),null)
       )).unNx()
     );
     return
     new Ex(
       new Tree.MEM(
         new Tree.ESEQ(
            midx
            ,
            ifThenElseExp(
              new RelCx(Tree.CJUMP.EQ,c1,new Ex(new Tree.CONST(1))),
              new Nx(err),
              new Ex(res)
            ).unEx()
         )
       )
     );
  }

  public Exp forExp(Exp i,Exp lo,Exp hi,Exp body,Temp.Label out, Level l){
    Tree.Stm init=(assignExp(i,lo)).unNx();
    Tree.Stm agg=(assignExp(
      i,
      binOpExp(Tree.BINOP.PLUS,i,new Ex(new Tree.CONST(1)))
    )).unNx();

    Exp nbody=new Nx(agg);
    if(body!=null) nbody=new Nx(new Tree.SEQ(body.unNx(),agg));
    Exp cond=(relOpExp(Tree.CJUMP.LE,i,hi,false,l));
    Tree.Stm ret=new Tree.SEQ(init,whileExp(cond,nbody,out).unNx());
    return new Nx(ret);
  }

  public Exp whileExp(Exp cond,Exp body,Temp.Label out){
    Temp.Label ltest=new Temp.Label();
    Temp.Label lbody=new Temp.Label();
    Tree.LABEL test=new Tree.LABEL(ltest);
    Tree.LABEL corpo=new Tree.LABEL(lbody);
    Tree.Stm b=new Tree.JUMP(ltest);
    if(body!=null)b=new Tree.SEQ(body.unNx(),new Tree.JUMP(ltest));
    Tree.Stm ret=
   new Tree.SEQ(
    new Tree.SEQ(
      new Tree.SEQ(
        test,
        new Tree.CJUMP(Tree.CJUMP.EQ,new Tree.CONST(1),cond.unEx(),lbody,out)
      ),
      new Tree.SEQ(corpo,b)
    ),
    new Tree.LABEL(out)
   );
    return new Nx(ret);
  }

  public Exp breakExp(Temp.Label l){
    return new Nx(new Tree.JUMP(l));
  }

  public Exp intExp(int l){return new Ex(new Tree.CONST(l));}

  public Exp stringExp(Level actL,String s){
    Temp.Label l;

    if(stol.containsKey(s)){
      l=(Temp.Label)stol.get(s);
    }
    else {
      l=new Temp.Label();
      stol.put(s,l);
      insertInFrag(new DataFrag(actL.frame.string(l,s), s));
    }
    return new Ex(new Tree.SNAME(l));
  }

  public Exp binOpExp(int op,Exp i,Exp ii){return new Ex(new Tree.BINOP(op,i.unEx(),ii.unEx()));}

  public Exp relOpExp(int op,Exp i,Exp ii,boolean str,Level l){
    if(str){
      Exp cft = intExp(1);
      return
         new RelCx(
            Tree.CJUMP.EQ,
            new Ex(
             l.frame.externalCall(
              "stringEqual",
              new Tree.ExpList(new Tree.CONST(op),
              	 new Tree.ExpList(i.unEx(),
              		 new Tree.ExpList(ii.unEx(),null)
              	 )
              )
             )
            ),
            cft
         );
    }
    return new RelCx(op,i,ii);
  }

  public Exp assignExp(Exp l,Exp r){return new Nx(new Tree.MOVE(l.unEx(),r.unEx()));}

  public Exp seqExp(ExpList x, boolean isVoid)
  {
    ExpNode f = x.first();
    if(f == null) return null;
    if(f.tail == null) {
      if(!isVoid) return new Ex(f.value.unEx());
      return new Nx(f.value.unNx());
    }
    Tree.Stm act = f.value.unNx();
    for(ExpNode i=f.tail; i!=x.last; i=i.tail)
      act = new Tree.SEQ(act, i.value.unNx());
    if(!isVoid)
      return
        new Ex(new Tree.ESEQ(act, x.last.value.unEx()));
    return
      new Nx(new Tree.SEQ(act, x.last.value.unNx()));
  }

  public Exp ifThenElseExp(Exp c,Exp a,Exp b){return new IfThenElseExp(c,a,b);}

  public Exp letExp(ExpList decs,Exp body,boolean isVoid)
  {
    Exp dec = seqExp(decs,false);
    Tree.Stm Tdec=null;
    if(dec!=null)Tdec=dec.unNx();
    if(!isVoid){
      if(Tdec!=null)return new Ex(new Tree.ESEQ(Tdec,body.unEx()));
      return body;
    }
    Temp.Label oo = new Temp.Label();
    Tree.Stm nbb = new Tree.JUMP(oo);
    if(body != null)
        nbb=body.unNx();
    if(Tdec != null)
      return new Nx(new Tree.SEQ(
                      new Tree.SEQ(Tdec,nbb),
                      new Tree.LABEL(oo)
                   ));

    return new Nx(new Tree.SEQ(nbb,new Tree.LABEL(oo)));
  }

  public Exp recordExp(Level l, int n, ExpList tl )
  {
    Tree.ExpList t = makeTreeExpList(tl);
    Tree.Stm ret = null;
    // In r ci sar il puntatore al record
    Tree.Exp r = new Tree.TEMP(new Temp.Temp());
    n--;

    //Scorri le inizializzazioni e crea le espressioni partendo dall'ultima
    for(Tree.ExpList t1 = t ;t1 != null;t1=t1.tail){
       Tree.Stm app =
            new Tree.MOVE(
                 new Tree.MEM(
                     new Tree.BINOP(
  			Tree.BINOP.PLUS,
  			r,
  			new Tree.CONST(n*l.frame.wordSize()))),
			// Nell'offset calcolato va memorizzato il risultato dell'expr
			// di inizializzazione corrispondente
  			t1.head);

  		if (ret == null)ret = app;
  		else ret = new Tree.SEQ(app,ret);
  		n--;
  	}

  	Tree.Stm chiamata = new Tree.MOVE(r,l.frame.externalCall("malloc",new Tree.ExpList(new Tree.CONST(num(t)*l.frame.wordSize()),null)));

  	if (ret == null)ret = chiamata;
  	else ret = new Tree.SEQ(chiamata,ret);

  	return new Ex((new Tree.ESEQ(ret,r)));
  }

  public int num(Tree.ExpList t )
  {
    if (t==null)return 0;
    else return (1 + num(t.tail));
  }

  // Riceve un Translate.ExpNode e converte in Tree.ExpList

  public Tree.ExpList makeTreeExpList(ExpNode args)
  {
    if(args == null) return null;
    return new Tree.ExpList(args.value.unEx(), makeTreeExpList(args.tail));
  }
  public Tree.ExpList makeTreeExpList(ExpList args)
  {
      return makeTreeExpList(args.first());
  }

  public Exp fieldVar(Level act, Exp addr,int i)
  {
     Tree.Stm err=new Tree.SEQ(
       new Ex(act.frame.externalCall(
           "print",
           new Tree.ExpList(stringExp(act,"\nErrore di runtime : puntatore al record nullo.\n").unEx(),null)
       )).unNx(),
       new Ex(act.frame.externalCall(
           "exit",
           new Tree.ExpList(intExp(0).unEx(),null)
       )).unNx()
    );

  	Tree.Exp app = (
 		new Tree.BINOP(
  			Tree.BINOP.PLUS,
  			addr.unEx(),
  			new Tree.CONST(i*act.frame.wordSize())
  			)
  		);

     return new Ex( new Tree.MEM(
     	  ifThenElseExp(
       new RelCx( Tree.CJUMP.EQ,addr,intExp(0)   ),
       new Nx(err),
       new Ex(app)
          ).unEx()));
  }

  public Tree.ExpList inv ( Tree.ExpList e){
  	Tree.ExpList app = null;
  	for (Tree.ExpList h = e ; h != null; h = h.tail){
  		app = new Tree.ExpList(h.head,app);
  	}
  	return app;
  }

  public Exp arrayExp(Exp size, Exp init, Level act) {
    Tree.TEMP r = new Tree.TEMP(new Temp.Temp());
    Tree.Exp e =
           act.frame.externalCall(
           "initArray",
           new
           Tree.ExpList(
            (binOpExp(
               Tree.BINOP.MUL,
               binOpExp(Tree.BINOP.PLUS,size,intExp(1)),
               intExp(act.frame.wordSize())
            )).unEx(),
            new Tree.ExpList(init.unEx(),null)
           )
       );
    return new Ex(
             new Tree.ESEQ(
               new Tree.SEQ(
                   new Tree.MOVE(r,e),
                   new Tree.MOVE(new Tree.MEM(r),size.unEx())
               ),
               r
             )
    );
  }

  public Exp callExp(Level g,Level f, ExpList elArgs){
    // L'espressione dovrebbe prendere il valore del link statico del frame corrente se  il primo dei formali
    Tree.ExpList args = makeTreeExpList(elArgs.first());
    Tree.Exp app = new Tree.TEMP(f.frame.FP());
    while (g != f.parent){
      // Rispetto al FP risalito riandiamo a prendere lo static link
      app = g.frame.formals.head.exp(app);
      g = g.parent;
    }
    return new Ex(new Tree.CALL(new Tree.NAME(f.frame.name),new Tree.ExpList(app,args)));
  }

}